opt_T <- function(Z,Z.group,R,R1,clusters,tau0,tau1,nsk,S=10,K=2,alpha=.05){
    
    oT_pvalue <- rep(NA,2)                 # p_values
    names(oT_pvalue) <- c("oT_pvalue0","oT_pvalue1")
    
    pair.multiplier <- apply(nsk,1,prod)

####### Under H0 ##################

    e <- R-tau0*Z


    probs0 <- pv(tau0,tau0,sigma(e)$s.z.hat,sigma(e)$s.g.hat)
    c0 <- probs0$c
    p0 <- probs0$p
    q0 <- probs0$q
    
    probs1 <- pv(tau0,tau1,sigma(e)$s.z.hat,sigma(e)$s.g.hat)
    c1 <- probs1$c
    p1 <- probs1$p
    q1 <- probs1$q
    
    V0 <- V(c0,p0,q0,nsk)
    V1 <- V(c1,p1,q1,nsk)
    E1 <- rep(2*c1-1,S)

    weights <- CAopt(V0,E1,V1)$weights
    
    if(max(eigen(Hf(weights,V0,V1,E1))$values)>0){stop;print("Did not find the maximum")}
  
    
    wilcox.store <- total_wilcox(e,Z.group,clusters,tau=tau0)
    
    oT.dist <- apply(rand,3,function(x){sum(t(x*weights/pair.multiplier)*wilcox.store)})

    oT <- sum(t(Z.group*weights/pair.multiplier)*wilcox.store)

    oT_pvalue["oT_pvalue0"] <-  sum(oT.dist<=oT)/2^S

    


##### Under H1 #############################

    e1 <- R1-tau0*Z


    probs01 <- pv(tau0,tau0,sigma(e1)$s.z.hat,sigma(e1)$s.g.hat)
    c01 <- probs01$c
    p01 <- probs01$p
    q01 <- probs01$q
    
    probs11 <- pv(tau0,tau1,sigma(e1)$s.z.hat,sigma(e1)$s.g.hat)
    c11 <- probs11$c
    p11 <- probs11$p
    q11 <- probs11$q

    V01 <- V(c01,p01,q01,nsk)
    V11 <- V(c11,p11,q11,nsk)
    E11 <- rep(2*c11-1,S)

    weights1 <- CAopt(V01,E11,V11)$weights
 
    if(max(eigen(Hf(weights1,V01,V11,E11))$values)>0){stop;print("Did not find the maximum")}    
    
    wilcox.store1 <- total_wilcox(e1,Z.group,clusters,tau=tau0)
    
    oT.dist1 <- apply(rand,3,function(x){sum(t(x*weights1/pair.multiplier)*wilcox.store1)})

    oT1 <- sum(t(Z.group*weights1/pair.multiplier)*wilcox.store1)
    
    oT_pvalue["oT_pvalue1"] <-  sum(oT.dist1<=oT1)/2^S
    

    
   
    

################# Statistic ##########################

    return(list(oT=oT,oT_pvalue=oT_pvalue))

}
